{
    *******************************************************
    * "De Delphi  C# avec BDS 2006"  ISBN 2-212-11768-X  *
    *******************************************************
    *                                                     *
    * Code source correspond aux exemples traits dans l' *
    * ouvrage.                                            *
    *                                                     *
    * Environment : Borland Developer Studio 2006         *
    * Test sur la version Architecte Franaise patch 1   *
    *                                                     *
    * Copyright   : Olivier Dahan                         *
    *                                                     *
    * Aucune copie, distribution, publication sans l'     *
    * accord exprs de l'auteur.                          *
    * Le prsent code source est fourni "tel quel"       *
    * titre d'illustration des propos techniques du livre *
    * Aucune garantie de fonctionnement ou d'adaptation   *
    * n'est fournie, aucune maintenance corrective ou     *
    * volutive ne sera fournie sur le prsent code.      *
    * Vous utilisez ce code sous votre seule responsabi-  *
    * lit et  vos risques et prils. L'auteur ne serait *
    * tre tenu pour responsable d'ventuelles pertes de  *
    * donnes ou de jouissance qui pourraient rsulter de *
    * l'utilisation du prsent code.                      *
    *                                                     *
    * Contact          : BDSLivre@e-naxos.com             *
    * Site de l'auteur : http://www.e-naxos.com           *
    *******************************************************

}


unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Borland.Vcl.StdCtrls, System.ComponentModel,
  Borland.Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    btnSerialiserVCL: TButton;
    Edit1: TEdit;
    Bevel1: TBevel;
    btnRelireVCL: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Bevel2: TBevel;
    Label4: TLabel;
    btnSerialiserDOTNET: TButton;
    Label5: TLabel;
    btnRelireDOTNET: TButton;
    Label6: TLabel;
    cbFMT: TCheckBox;
    ListBox1: TListBox;
    btnEffacer: TButton;
    procedure btnEffacerClick(Sender: TObject);
    procedure btnSerialiserVCLClick(Sender: TObject);
    procedure btnRelireVCLClick(Sender: TObject);
    procedure btnSerialiserDOTNETClick(Sender: TObject);
    procedure btnRelireDOTNETClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation
// dclarations ncessaire pour la srialisation du framework
uses System.IO,
  System.Runtime.Serialization,
  System.Runtime.Serialization.Formatters,
  System.Runtime.Serialization.Formatters.Binary,
  System.Runtime.Serialization.Formatters.Soap;

{$R *.nfm}

// **** Srialisation par la VCL ****

procedure TForm1.btnSerialiserVCLClick(Sender: TObject);
begin
 RegisterClass(TEdit);
 WriteComponentResFile('test.bin',edit1);
 edit1.Free;
 label2.Visible:=false;
end;

procedure TForm1.btnRelireVCLClick(Sender: TObject);
begin
 edit1 := TEdit.Create(self);
 ReadComponentResFile('test.bin',edit1);
 edit1.Parent := self;
 label2.Visible:=true;
end;

// ***** Srialisation par le framework *****

type
 // utilisation de l'attribut personnalis pour marquer la classe
 [Serializable]
 // la classe  srialiser
 TMaClasseSerialisable = class
  public
  [Serializable]
  // classe imbrique
  type TclasseImbrique = class
   private
   champ : integer;
   protected
    procedure seta(const i:integer);
   public
    constructor Create(value:integer); override;
    property a : integer read champ write seta;
   end;
   // type imbriqu
   type Tarray = array of TClasseImbrique;
  private
   FChamp1 : integer;
   FChamp2 : integer;
   FChamp4 : Tarray;
   [NonSerialized]
   FChamp3 : integer; // ne sera pas srialis
  protected
   procedure setia(index:integer;value:TClasseImbrique);
   function getia(index:integer):TClasseImbrique;
  public
   Constructor Create; virtual;
   property Champ : integer read FChamp1 write FChamp1;
   property ClassArray[index:integer]:TClasseImbrique read getia write setia;
 end;

{ TMaClasseSerialisable.TclasseImbrique }
constructor TMaClasseSerialisable.TclasseImbrique.Create(value: integer);
begin
  inherited create;
  champ:=value;
end;

procedure TMaClasseSerialisable.TclasseImbrique.seta(const i: integer);
begin
 champ := i;
end;

{ TMaClasseSerialisable }

constructor TMaClasseSerialisable.Create;
begin
  inherited;
  Setlength(FChamp4,11);
end;

function TMaClasseSerialisable.getia(index: integer): TClasseImbrique;
begin
 if index in [0..10] then result := Fchamp4[index];
end;

procedure TMaClasseSerialisable.setia(index: integer; value: TClasseImbrique);
begin
 if index in [0..10] then Fchamp4[index]:=value;
end;

 procedure SerialiseMaClasse(Obj: TMaClasseSerialisable;Fichier:string;Binaire:boolean=true);
var
  Formatter: IFormatter;
  Stream: System.IO.FileStream;
begin
  Stream := FileStream.Create(Fichier, FileMode.Create);
  if Binaire then
   Formatter := BinaryFormatter.Create as IFormatter else
   Formatter := SoapFormatter.Create as IFormatter;
  Formatter.Serialize(Stream, Obj);
  Stream.Close;
end;

function DeserialiseMaClasse(Fichier:string;Binaire:boolean=true): TMaClasseSerialisable;
var
  Formatter: IFormatter;
  Stream: System.IO.FileStream;
begin
  Stream := FileStream.Create(Fichier, FileMode.Open);
  if Binaire then
    Formatter := BinaryFormatter.Create as IFormatter else
    Formatter := SoapFormatter.Create as IFormatter;
  Result := TMaClasseSerialisable(Formatter.Deserialize(Stream));
  Stream.Close;
end;


// srialisation
procedure TForm1.btnSerialiserDOTNETClick(Sender: TObject);
var CS : TMaClasseSerialisable; F:String; i:integer;
begin
 CS := TMaClasseSerialisable.Create;
 CS.Champ := 357;
 CS.FChamp2 := 753;
 CS.FChamp3 := 999; // ne sera pas srialis
 ListBox1.clear;
 For i:=0 to 10 do
  begin
   CS.ClassArray[i] := TMaClasseSerialisable.TclasseImbrique.Create(random(1000)+1) ;
   listbox1.Items.Add(cs.ClassArray[i].a.ToString);
  end;

 if cbFMT.Checked then F:='Objet.xml' else F:='Objet.bin';
 SerialiseMaClasse(CS,F,not cbFMT.Checked);
end;

// dsrialisation
procedure TForm1.btnRelireDOTNETClick(Sender: TObject);
var CS : TMaClasseSerialisable; F:String;
  i: Integer;
begin
 if cbFMT.Checked then F:='Objet.xml' else F:='Objet.bin';
 CS := DeserialiseMaClasse(F,not cbFMT.Checked);
 Label6.Caption := 'Champ public= '+CS.Champ.tostring+
                   ' / Priv= '+CS.FChamp2.tostring+
                   ' / n/s= '+CS.FChamp3.tostring;
 for i := 0 to 10 do
  listbox1.items.add(cs.ClassArray[i].a.tostring);
end;

// pour effacer les donnes afin de voir l'effet de la relecture du flux
procedure TForm1.btnEffacerClick(Sender: TObject);
begin
 label6.Caption := '----';
 ListBox1.Clear;
end;

end.
